using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;

public class CameraControllerScript : MonoBehaviour
{
    public float sensitivity = 5.0f;
    public float smoothFactor = 0.5f;

    CameraInput cameraInput;

    Vector2 currentMovementInput;
    Vector2 currentZoomInput;
    //Vector2 turn;
    //public float pLerp = 0.02f;
    
    bool isMoving;
    private float rotationX;
    private float rotationY;
    //private Vector3 smoothVelocity = Vector3.zero;
    private Transform target;
    public float maxFOV = 70f;
    public float minFOV = 30f;
    
    void Awake(){
        cameraInput = new CameraInput();
        target = this.transform.parent.gameObject.transform;

        cameraInput.CameraControls.Move.started += onMovementInput;
        cameraInput.CameraControls.Move.performed += onMovementInput;
        cameraInput.CameraControls.Move.canceled += onMovementInput;

        cameraInput.CameraControls.Zoom.started += onZoomInput;
        cameraInput.CameraControls.Zoom.performed += onZoomInput;
        cameraInput.CameraControls.Zoom.canceled += onZoomInput;

    }

    void onZoomInput(InputAction.CallbackContext context){
        currentZoomInput = context.ReadValue<Vector2>();
        Vector3 currentPosition = transform.localPosition;
        //Debug.Log(currentZoomInput);
        if(currentZoomInput.y < 0f){
            if(GetComponent<Camera>().fieldOfView < maxFOV){
                GetComponent<Camera>().fieldOfView++;
            }
        }else if(currentZoomInput.y > 0f){
            if(GetComponent<Camera>().fieldOfView > minFOV){
                GetComponent<Camera>().fieldOfView--;
            }
        }
        transform.localPosition = currentPosition;

    }


    void onMovementInput(InputAction.CallbackContext context){
        currentMovementInput = context.ReadValue<Vector2>();
        //Debug.Log(currentMovementInput);
        
        isMoving = currentMovementInput.x != 0 || currentMovementInput.y != 0;

        rotationX = currentMovementInput.x * sensitivity * Time.deltaTime;
        rotationY = currentMovementInput.y * sensitivity * Time.deltaTime;

        transform.RotateAround(target.transform.position, Vector3.up, rotationX);


        //transform.parent.gameObject.transform.RotateAround(target.transform.position, Vector3.up, rotationX);
        //transform.RotateAround(target.transform.position, Vector3.right, rotationY);

        //Vector3 nextRotation = new Vector3(rotationX, rotationY);

        /*currentRotation = Vector3.SmoothDamp(currentRotation, nextRotation, ref smoothVelocity, smoothFactor);
        transform.localEulerAngles = currentRotation;*/

        //transform.position = target.position - transform.forward * transform.position.z;
    }

    void OnEnable(){
        cameraInput.CameraControls.Enable();
    }

    void OnDisable(){
        cameraInput.CameraControls.Disable();
    }

    // Update is called once per frame
    void Update()
    {
        Vector3 targetPosition = target.position;
        targetPosition.y += 1.7f;
        transform.LookAt(targetPosition);
        
    }
}
