using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;
using System.IO;


public class CreateMap : MonoBehaviour
{
    /*public Material segmentMaterial;
    public Material areaWaterMaterial;
    public Material lineWaterMaterial;
    public Material regionMaterial;
    public Material extrudedMaterial;
    public Material modeledMaterial;*/

    // Start is called before the first frame update
    public void CrearMapa(int indexLloc)
    {

        string txtFilesPath = Application.dataPath;
        txtFilesPath = txtFilesPath.Remove(txtFilesPath.IndexOf("Assets"));
        txtFilesPath = string.Concat(txtFilesPath, "txtFiles");
        switch(indexLloc){
            case 1:
                txtFilesPath = string.Concat(txtFilesPath, "\\TxtFiles_Banyoles");
                break;
            case 2:
                txtFilesPath = string.Concat(txtFilesPath, "\\TxtFiles_Breda");
                break;
            case 3:
                txtFilesPath = string.Concat(txtFilesPath, "\\TxtFiles_Ulldecona");
                break;
            case 4:
                txtFilesPath = string.Concat(txtFilesPath, "\\TxtFiles_Vidreres");
                break;
            default:
                Debug.Log("error index");
                break;
        }

        //Check the number of txt files for the loop
        //string p = @"C:\UnityProjects\TestCrearGO\Assets\TextFiles\Transforms";
        string p = Path.Combine(txtFilesPath, "Transforms");
        int fCount = (Directory.GetFiles(p, "*", SearchOption.AllDirectories).Length);// /2;
        

        int numLineWater = 0;
        int numAreaWater = 0;
        int numSegment = 0;
        int numRegion = 0;
        int numModeledStructure = 0;
        int numExtrudedStructure = 0;

        GameObject parentLineWater = new GameObject("Lines Water");
        parentLineWater.transform.parent = gameObject.transform;
        GameObject parentAreaWater = new GameObject("Areas Water");
        parentAreaWater.transform.parent = gameObject.transform;
        GameObject parentSegment = new GameObject("Segments");
        parentSegment.transform.parent = gameObject.transform;
        GameObject parentRegion = new GameObject("Regions");
        parentRegion.transform.parent = gameObject.transform;
        GameObject parentModeledStructure = new GameObject("Modeled Structures");
        parentModeledStructure.transform.parent = gameObject.transform;
        GameObject parentExtrudedStructure = new GameObject("Extruded Structures");
        parentExtrudedStructure.transform.parent = gameObject.transform;
        var flags = StaticEditorFlags.NavigationStatic;

        GameObjectUtility.SetStaticEditorFlags(parentLineWater, flags);
        GameObjectUtility.SetStaticEditorFlags(parentAreaWater, flags);
        GameObjectUtility.SetStaticEditorFlags(parentSegment, flags);
        GameObjectUtility.SetStaticEditorFlags(parentRegion, flags);
        GameObjectUtility.SetStaticEditorFlags(parentModeledStructure, flags);
        GameObjectUtility.SetStaticEditorFlags(parentExtrudedStructure, flags);  


        //For every file
        for(var i = 0; i<fCount; i++){
            //Open all needed files
            StreamReader transformFile = new StreamReader(Path.Combine(txtFilesPath, "Transforms", i.ToString() + ".txt"));
            StreamReader trianglesFile = new StreamReader(Path.Combine(txtFilesPath, "Triangles", i.ToString() + ".txt"));
            StreamReader verticesFile =  new StreamReader(Path.Combine(txtFilesPath, "Vertices", i.ToString() + ".txt"));

            //Create the new game object and add the needed components (meshFilter and meshRender)
            GameObject go = new GameObject();
            Mesh m = new Mesh();
            Mesh mesh = go.AddComponent<MeshFilter>().mesh = m;
            //Material mat = new Material(Shader.Find("Standard"));
            Renderer newMaterial = go.AddComponent<MeshRenderer>();
            MeshCollider goColl = go.AddComponent<MeshCollider>();
            //co.isTrigger = true;

            //Get the type of gameObject in order to know what color it's going to be painted
            string color = transformFile.ReadLine();

            //Read the tranformFile and assign the position to the new gameObject's transform. After close the file
            Vector3 v3aux = new Vector3(float.Parse(transformFile.ReadLine()), float.Parse(transformFile.ReadLine()), float.Parse(transformFile.ReadLine()));
            go.transform.position = v3aux;
            transformFile.Close();

            //Declared aux variable and a Vector3 list for the vertices
            string auxFiles = verticesFile.ReadLine();
            List<Vector3> meshVertices = new List<Vector3>();

            //while there's still lines left in the verticesFile, create a new Vector3 then add it to the Vector3 array created previously
            while(auxFiles != null){
                Vector3 aux = new Vector3(float.Parse(auxFiles), float.Parse(verticesFile.ReadLine()), float.Parse(verticesFile.ReadLine()));
                meshVertices.Add(aux);
                auxFiles = verticesFile.ReadLine();
            }
            //Once the Vector3 array is completed, assign it to the vertices of the mesh from the new game object. Then close the file as it's no longer needed
            mesh.vertices = meshVertices.ToArray();
            verticesFile.Close();


            //Declare a int list for the triangles. Then read the first line of the trianglesFile
            List<int> meshTriangles = new List<int>();
            auxFiles = trianglesFile.ReadLine();


            //While there'se still lines left in the trianglesFile, add the read line to the int array created previously
            while(auxFiles != null){
                //meshTriangles.Add(int.Parse(auxFiles));
                meshTriangles.Add(int.Parse(auxFiles));
                auxFiles = trianglesFile.ReadLine();
            }
            //Once the int array is completed, assign it to the triangles of the mesh from the new game object. Then close the file as it's no longer needed
            mesh.triangles = meshTriangles.ToArray();
            trianglesFile.Close();


            Vector3[] vertices = mesh.vertices;
            Vector2[] uvs = new Vector2[vertices.Length];
            for(int j = 0; j < uvs.Length; j++){
                uvs[j] = new Vector2(vertices[j].x, vertices[j].z);
            }
            mesh.uv = uvs;



            
            //print(color);
            if(color.Equals("lw")){
                //print("ok lw");
                go.name = "LineWater" + numLineWater.ToString();
                numLineWater++;
                go.tag = "LineWater";
                newMaterial.material = Resources.Load("Materials/LineWaterMaterial") as Material;
                //newMaterial.color = new Color(37/255f, 116/255f, 169/255f); //deep blue
                Vector3 auxV = go.transform.position;
                auxV.y -= 0.001f;
                go.transform.position = auxV;
                go.transform.parent = parentLineWater.transform;
                goColl.convex = true;
                goColl.isTrigger = true;
            }
            else if(color.Equals("aw")){
                //print("ok aw");
                go.name = "AreaWater" + numAreaWater.ToString();
                numAreaWater++;
                go.tag = "AreaWater";
                newMaterial.material = Resources.Load("Materials/AreaWaterMaterial") as Material;
                //newMaterial.color = new Color(25/255f, 181/255f, 254/255f); //light blue
                Vector3 auxV = go.transform.position;
                auxV.y -= 0.002f;
                go.transform.position = auxV;
                go.transform.parent = parentAreaWater.transform;
                goColl.convex = true;
                goColl.isTrigger = true;
            }
            else if(color.Equals("s")){
                go.name = "Segment" + numSegment.ToString();
                numSegment++;
                go.tag = "Segment";
                newMaterial.material = Resources.Load("Materials/asphalt") as Material;
                //newMaterial.color = new Color(191/255f, 191/255f, 191/255f); //gray
                Vector3 auxV = go.transform.position;
                auxV.y += 0.002f;
                go.transform.position = auxV;
                go.transform.parent = parentSegment.transform;
                GameObjectUtility.SetStaticEditorFlags(go, flags);
            }
            else if(color.Equals("r")){
                go.name = "Region" + numRegion.ToString();
                numRegion++;
                go.tag = "Region";
                newMaterial.material = Resources.Load("Materials/RegionMaterial") as Material;
                //newMaterial.color = new Color(30/255f, 130/255f, 76/255f); //green
                Vector3 auxV = go.transform.position;
                auxV.y += 0.001f;
                go.transform.position = auxV;
                go.transform.parent = parentRegion.transform;
                GameObjectUtility.SetStaticEditorFlags(go, flags);
            }
            else if(color.Equals("ms")){
                go.name = "ModeledStructure" + numModeledStructure.ToString();
                numModeledStructure++;
                go.tag = "ModeledStructure";
                Material auxMat = new Material(Shader.Find("Standard"));
                go.GetComponent<MeshRenderer>().material = auxMat;
                newMaterial.material.color = new Color(233/255f, 212/255f, 96/255f); //golden
                Vector3 auxV = go.transform.position;
                //auxV.y -= 0.6f;
                go.transform.position = auxV;
                go.transform.parent = parentModeledStructure.transform;
                GameObjectUtility.SetStaticEditorFlags(go, flags);
                goColl.convex = true;
                goColl.isTrigger = true;
            }
            else if(color.Equals("es")){
                go.name = "ExtrudedStructure" + numExtrudedStructure.ToString();
                numExtrudedStructure++;
                go.tag = "ExtrudedStructure";
                Material auxMat = new Material(Shader.Find("Standard"));
                go.GetComponent<MeshRenderer>().material = auxMat;
                newMaterial.sharedMaterial.color = new Color(228/255f, 120/255f, 51/255f); //brown
                Vector3 auxV = go.transform.position;
                //auxV.y -= 0.6f;
                go.transform.position = auxV;
                go.transform.parent = parentExtrudedStructure.transform;
                GameObjectUtility.SetStaticEditorFlags(go, flags);
                goColl.convex = true;
                goColl.isTrigger = true;
            }
            else{
                print("Knowing type fail");
                Material auxMat = new Material(Shader.Find("Standard"));
                newMaterial.material = auxMat;
                newMaterial.material.color = new Color(0.0f, 0.0f, 0.0f);
            }
        }

        Vector3 center = Vector3.zero;
        Bounds bounds = new Bounds(center,Vector3.zero);
        float numChildren = 0f;
        foreach(Transform child in gameObject.transform){
            foreach(Transform grandChild in child.transform){
                Bounds grandChildBounds = grandChild.gameObject.GetComponent<Renderer>().bounds;
                center+= grandChildBounds.center;
                bounds.Encapsulate(grandChildBounds);
                numChildren++;
            }
        }
        center /= numChildren;
        /*Bounds bounds = new Bounds(center,Vector3.zero);
        foreach(Transform child in gameObject.transform){
            bounds.Encapsulate(child.gameObject.GetComponent<Renderer>().bounds);
        }*/

        //GameObject fronteraMapa = GameObject.CreatePrimitive(PrimitiveType.Cube);
        GameObject fronteraMapa = Instantiate(Resources.Load("MapBorders") as GameObject, gameObject.transform);
        GameObject terra = GameObject.CreatePrimitive(PrimitiveType.Cube);

        terra.name = "Floor";
        terra.transform.position = new Vector3(bounds.center.x, -0.6f, bounds.center.z);
        terra.transform.localScale = new Vector3(bounds.size.x, 1, bounds.size.z);
        //Material auxMat = new Material(Shader.Find("Standard"));
        Renderer terraMaterial = terra.GetComponent<Renderer>();// = auxMat;
        terraMaterial.material = Resources.Load("Materials/FloorMaterial") as Material;
        //terraMaterial.color = new Color(71/255f, 174/255f,71/255f);
        terra.AddComponent<MeshCollider>();


        fronteraMapa.name = "MapBorders";
        fronteraMapa.transform.position = bounds.center;
        fronteraMapa.transform.localScale = new Vector3(bounds.size.x-5, bounds.size.y+1, bounds.size.z-5);

        Material auxMat2 = new Material(Shader.Find("Standard"));
        auxMat2.SetColor("_Color", new Color(135/255f,206/255f,235/255f));
        auxMat2.SetFloat("_Mode", 3);
        auxMat2.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.SrcAlpha);
        auxMat2.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);
        auxMat2.EnableKeyword("_ALPHABLEND_ON");
        auxMat2.renderQueue = 3000;

        fronteraMapa.GetComponent<MeshRenderer>().material = auxMat2;
        MeshCollider colli = fronteraMapa.AddComponent<MeshCollider>();
        colli.convex = true;
        colli.isTrigger = true;

        //fronteraMapa.transform.parent = gameObject.transform;
        terra.transform.parent = gameObject.transform;

        GameObjectUtility.SetStaticEditorFlags(terra, flags);
        //GameObjectUtility.SetStaticEditorFlags(parentSegment, flags);
        //GameObjectUtility.SetStaticEditorFlags(parentRegion, flags);
        //GameObjectUtility.SetStaticEditorFlags(parentModeledStructure, flags);
        //GameObjectUtility.SetStaticEditorFlags(parentExtrudedStructure, flags);

    }
}
