using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;
using System;

public class GameControllerScript : MonoBehaviour
{

    public GameObject personatge;
    public GameObject enemy1;
    public GameObject enemy2;
    public GameObject enemy3;
    public GameObject enemy4;
    GameObject player;
    //private float elapsedTime = 0;
    private List<Collider> spawnableRoads;
    public float maxEnemies = 5.0f;
    public float spawnRate = 10.0f;
    private int currentEnemies = 0;

    //private bool isPlayerDead = false;
    public GameObject fadeOutPanel;

    // Start is called before the first frame update
    public void Start()
    {
        spawnableRoads = new List<Collider>();
        SpawnPlayer();
        InvokeRepeating("LookPlayersNearRoads", 1f, 1f);
        InvokeRepeating("CheckSpawnEnemies", spawnRate, spawnRate);
        fadeOutPanel.GetComponent<FadeOut>().FadeIn();
    }

    void SpawnPlayer(){
        GameObject[] roads = GameObject.FindGameObjectsWithTag("Segment");
        int numberOfRoads = roads.Length;
        int spawnRoadNumber = new System.Random().Next(0, numberOfRoads);
        GameObject spawnRoad = roads[spawnRoadNumber];
        Vector3 spawnPosition = spawnRoad.transform.position;
        spawnPosition.y += 2;
        player = Instantiate(personatge, spawnPosition, Quaternion.identity);
        player.layer = 6;
        player.tag = "Player";

    }

    void LookPlayersNearRoads(){
        Vector3 playerPos = player.transform.position;
        //Debug.Log(player.transform.position);
        Collider[] nearGameObjects = Physics.OverlapSphere(playerPos, 150); //Array amb tots els gameObjects que estan dins un radi
        Collider[] tooCloseGameObjects = Physics.OverlapSphere(playerPos, 50); //Array perquè no apareguin enemics massa aprop
        
        //Ara tenim una array amb tots els gameObjects que estan aprop, però només ens interessen els "segment", per tant es crea una llista per cada array 
        //i es filtren els gameObjects que hi ha dins. Fer les llistes és útil perquè després és més facil filtrar els segment que estant massa aprop
        List<Collider> nearRoads = new List<Collider>();
        List<Collider> tooCloseRoads = new List<Collider>();

        for(var i = 0; i<nearGameObjects.Length; i++){
            if(nearGameObjects[i].gameObject.tag == "Segment"){
                //Debug.Log(i.ToString());
                nearRoads.Add(nearGameObjects[i]);
            }
        }
        for(var i = 0; i<tooCloseGameObjects.Length; i++){
            if(tooCloseGameObjects[i].gameObject.tag == "Segment"){
                //Debug.Log(i.ToString());
                tooCloseRoads.Add(tooCloseGameObjects[i]);
            }
        }

        spawnableRoads = nearRoads.Except(tooCloseRoads).ToList();

    }

    void CheckSpawnEnemies(){
        if(currentEnemies < maxEnemies){
            //Debug.Log(currentEnemies);
            int kindOfEnemy = new System.Random().Next(0, 4);
            int nSpawnableRoads = spawnableRoads.Count;
            int nSpawnerRoad = new System.Random().Next(0, nSpawnableRoads);
            Collider spawnRoad;
            try{
                spawnRoad = spawnableRoads.ElementAt(nSpawnerRoad);
                /*GameObject enemy = GameObject.CreatePrimitive(PrimitiveType.Cube);
                enemy.name = "enemy"; */
                Vector3 spawnPosition = spawnRoad.transform.position;
                spawnPosition.y += 2;
                switch(kindOfEnemy){
                    case 0:
                        Instantiate(enemy1, spawnPosition, Quaternion.identity);
                        enemy1.layer = 7;
                        break;
                    case 1:
                        Instantiate(enemy2, spawnPosition, Quaternion.identity);
                        enemy2.layer = 7;
                        break;
                    case 2:
                        Instantiate(enemy3, spawnPosition, Quaternion.identity);
                        enemy3.layer = 7;
                        break;
                    case 3:
                        Instantiate(enemy4, spawnPosition, Quaternion.identity);
                        enemy4.layer = 7;
                        break;
                    default:
                        Debug.Log("No s'ha spawnejat cap enemic");
                        break;
                }
            }
            catch(Exception e){
                Debug.Log(e);
            } 
            //enemy.transform.position = spawnPosition;
            currentEnemies++;
        }       
    }

    public void playerDead(){
        CancelInvoke();
        GameObject[] enemies = GameObject.FindGameObjectsWithTag("Enemy");
        try{
            foreach(GameObject enemic in enemies){
                enemic.GetComponent<EnemyController>().playerDead();
                //Debug.Log(enemic.name);
            }
        }
        catch(Exception e){
            Debug.Log(e);
        }  
    }

    public void RestartGamePlay(){
        GameObject[] enemies = GameObject.FindGameObjectsWithTag("Enemy");
        foreach(GameObject enemic in enemies){
            Destroy(enemic);
            //Debug.Log(enemic.name);
        }
        Destroy(player);
    }

    public void CallFadeOut(){
        fadeOutPanel.GetComponent<FadeOut>().FadeOutAnimation();
    }

}
